/[gentoo-x86]/eclass/leechcraft.eclass
Gentoo

Contents of /eclass/leechcraft.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.10 - (show annotations) (download)
Wed May 8 10:25:48 2013 UTC (19 months, 2 weeks ago) by pinkbyte
Branch: MAIN
Changes since 1.9: +5 -11 lines
Restict supported EAPIs(due to pkg_pretend), some logic cleanup

1 # Copyright 1999-2013 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/leechcraft.eclass,v 1.9 2013/04/30 07:51:24 pinkbyte Exp $
4 #
5 # @ECLASS: leechcraft.eclass
6 # @MAINTAINER:
7 # leechcraft@gentoo.org
8 # @AUTHOR:
9 # 0xd34df00d@gmail.com
10 # NightNord@niifaq.ru
11 # @BLURB: Common functions and setup utilities for the LeechCraft app
12 # @DESCRIPTION:
13 # The leechcraft eclass contains a common set of functions and steps
14 # needed to build LeechCraft core or its plugins.
15 #
16 # Though this eclass seems to be small at the moment, it seems like a
17 # good idea to make all plugins inherit from it, since all plugins
18 # have mostly the same configuring/build process.
19 #
20 # Thanks for original eclass to Andrian Nord <NightNord@niifaq.ru>.
21 #
22 # Only EAPI >1 supported
23
24 case ${EAPI:-0} in
25 4|5) ;;
26 0|1|2|3) die "EAPI not supported, bug ebuild mantainer" ;;
27 *) die "Unknown EAPI, bug eclass maintainers" ;;
28 esac
29
30 inherit cmake-utils toolchain-funcs versionator
31
32 if [[ ${PV} == 9999 ]]; then
33 EGIT_REPO_URI="git://github.com/0xd34df00d/leechcraft.git"
34 EGIT_PROJECT="leechcraft"
35
36 inherit git-2
37 else
38 DEPEND="app-arch/xz-utils"
39 SRC_URI="mirror://sourceforge/leechcraft/leechcraft-${PV}.tar.xz"
40 S="${WORKDIR}/leechcraft-${PV}"
41 fi
42
43 HOMEPAGE="http://leechcraft.org/"
44 if version_is_at_least 0.5.95; then
45 LICENSE="Boost-1.0"
46 else
47 LICENSE="GPL-3"
48 fi
49
50 # @ECLASS-VARIABLE: LEECHCRAFT_PLUGIN_CATEGORY
51 # @DEFAULT_UNSET
52 # @DESCRIPTION:
53 # Set this to the category of the plugin, if any.
54 : ${LEECHCRAFT_PLUGIN_CATEGORY:=}
55
56 if [[ "${LEECHCRAFT_PLUGIN_CATEGORY}" ]]; then
57 CMAKE_USE_DIR="${S}"/src/plugins/${LEECHCRAFT_PLUGIN_CATEGORY}/${PN#lc-}
58 elif [[ ${PN} != lc-core ]]; then
59 CMAKE_USE_DIR="${S}"/src/plugins/${PN#lc-}
60 else
61 CMAKE_USE_DIR="${S}"/src
62 fi
63
64 EXPORT_FUNCTIONS "pkg_pretend"
65
66 # @FUNCTION: leechcraft_pkg_pretend
67 # @DESCRIPTION:
68 # Determine active compiler version and refuse to build
69 # if it is not satisfied at least to minimal version,
70 # supported by upstream developers
71 leechcraft_pkg_pretend() {
72 debug-print-function ${FUNCNAME} "$@"
73
74 if version_is_at_least 0.5.85; then
75 # 0.5.85 and later requires at least gcc 4.6
76 if [[ ${MERGE_TYPE} != binary ]]; then
77 [[ $(gcc-major-version) -lt 4 ]] || \
78 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 6 ]] ) \
79 && die "Sorry, but gcc 4.6 or higher is required."
80 fi
81 fi
82 }

  ViewVC Help
Powered by ViewVC 1.1.20